package de.uni_passau.spl.featurebite;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.apache.log4j.Logger;
import org.objectweb.asm.tree.ClassNode;

import de.uni_passau.spl.featurebite.spl.SPLStructure;
import de.uni_passau.spl.featurebite.stubs.StubUtil;
import de.uni_passau.spl.featurebite.util.ClassNodeTransformer;

/**
 * TODO doc
 * 
 * Removes stubs only if necessary.
 * 
 * @author Claus Hunsen
 * 
 */
public class DynamicComposer extends Composer {

	// TODO doc
	protected final static Logger logger = Logger
			.getLogger(DynamicComposer.class);

	public DynamicComposer(SPLStructure spl, String classpath)
			throws FileNotFoundException, IOException {
		super(spl, classpath);

		this.stubsPresent = true;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * Removes remaining stubs adaptively.
	 * 
	 * @param classNode
	 * @return
	 */
	@Override
	protected ClassNode postCompositionSingleFeatureFile(
			ClassNode classNode) {
		/*
		 * remove stubs
		 */
		return StubUtil.removeStubsDynamically(classNode);
	}

	/**
	 * Just loads the file.
	 * 
	 * @param file
	 * @return
	 */
	@Override
	protected ClassNode getClassNodeFor(File file) throws IOException,
			FileNotFoundException {
		ClassNode baseNode;

		// load file into class node
		if (renamedFiles.containsKey(file)) {
			baseNode = ClassNodeTransformer.createClassNodeFrom(renamedFiles
					.get(file));
		} else {
			baseNode = ClassNodeTransformer.createClassNodeFrom(file);
		}

		return baseNode;
	}

}
