package de.uni_passau.spl.featurebite.spl;

import java.io.IOException;

/**
 * Signals that one or more feature directories specified in a .features file do
 * not exist or that the .features file is empty.
 * 
 * @author Sergiy Kolesnikov
 * @author Claus Hunsen
 */
public class FeatureDirNotFoundException extends IOException {

	/**
	 * Generated serial version ID.
	 */
	private static final long serialVersionUID = 5233966237275453376L;

	/**
	 * Constructs a new exception with the specified detail message.
	 * 
	 * @param message
	 *            the detail message.
	 */
	public FeatureDirNotFoundException(String message) {
		super(message);
	}

	/**
	 * Default constructor.
	 */
	public FeatureDirNotFoundException() {
		super();
	}

}
