package de.uni_passau.spl.featurebite.util;

import java.lang.management.ManagementFactory;
import java.lang.management.ThreadMXBean;

public class Timer {

	private static Timer instance;

	private final static ThreadMXBean bean = ManagementFactory.getThreadMXBean();

	private long start;

	private Timer() {
	}

	public static Timer getInstance() {
		if (instance == null) {
			instance = new Timer();
		}
		return instance;
	}

	/** Get CPU time in nanoseconds. */
	public static long getCpuTime() {
		return bean.isCurrentThreadCpuTimeSupported() ? bean
				.getCurrentThreadCpuTime() : 0L;
	}

	public void start() {
		start = getCpuTime();
	}

	public long end() {
		return getCpuTime() - start;
	}

}
