package constructor;

import static org.junit.Assert.assertTrue;

import java.io.File;

import org.apache.commons.io.FileUtils;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import de.uni_passau.spl.featurebite.Launcher;

public class ConstructorOriginalCallTest {

	private String[] args;
	private File compPath;
	private File aGen;
	private File bGen;

	@Before
	public void setUp() throws Exception {
		File path = new File("testcases/constructor/");
		File ff = FileUtils.getFile(path, "constructorComp.features");
		
		compPath = FileUtils.getFile(path, "constructorComp/");
		aGen = FileUtils.getFile(compPath, "A.class");
		bGen = FileUtils.getFile(compPath, "B.class");

		args = new String[3];
		args[0] = "-basedir";
		args[1] = path.toString();
		args[2] = ff.toString();
	}

	@After
	public void tearDown() throws Exception {
		FileUtils.deleteDirectory(compPath);
	}

	@Test
	public void test() {
		 Launcher.main(args);

		 assertTrue(compPath.exists() && compPath.isDirectory());
		 assertTrue(aGen.exists() && aGen.isFile());
		 assertTrue(bGen.exists() && bGen.isFile());
	}

}
