package stubs;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Map;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.objectweb.asm.tree.ClassNode;

import de.uni_passau.spl.featurebite.stubs.StubUtil;
import de.uni_passau.spl.featurebite.util.ClassNodeTransformer;
import de.uni_passau.spl.featurebite.util.CountMap;
import de.uni_passau.spl.featurebite.util.CountMap.MutableInteger;

public class StubRemovalTest {

	// FIXME 10 - adjust project structure to src/main/java && src/test/java
	
	private File path;
	private File testFile;
	// private File outFile;
	private ClassNode classNode;

	@Before
	public void before() throws FileNotFoundException, IOException {
		path = new File("testcases/stubs/");
		// outFile = new File(path, "gen/A.class");

		testFile = new File(path, "A.class");
		classNode = ClassNodeTransformer.createClassNodeFrom(testFile);
	}

	@Test
	public void testSensitiveStubRemoval() throws IOException {
		/*
		 * counts must be 1 or 2 for special methods
		 */

		CountMap countBefore = StubUtil.countMethodsAndFields(classNode);
		for (Map.Entry<String, MutableInteger> c : countBefore.entrySet()) {
			String id = c.getKey();
			MutableInteger count = c.getValue();
			if (id.equals("method1#()V") || id.equals("field2+I")) {
				Assert.assertTrue(count.getValue() == 2);
			} else {
				Assert.assertTrue(count.getValue() == 1);
			}
		}

		// List<FieldNode> fields = classNode.fields;
		// for (FieldNode methodNode : fields) {
		// if (methodNode.visibleAnnotations != null) {
		// for (AnnotationNode an : methodNode.visibleAnnotations) {
		// System.out.println("@" + an.desc + "\n"+methodNode.name +
		// methodNode.desc + "\n");
		// }
		// }
		// }
		//
		// List<MethodNode> methods = classNode.methods;
		// for (MethodNode methodNode : methods) {
		// if (methodNode.visibleAnnotations != null) {
		// for (AnnotationNode an : methodNode.visibleAnnotations) {
		// System.out.println("@" + an.desc + "\n"+methodNode.name +
		// methodNode.desc + "\n");
		// }
		// }
		// }

		/*
		 * remove the stubs
		 */

		classNode = StubUtil.removeStubsDynamically(classNode);

		/*
		 * counts must be 1 for all fields and methods
		 */

		CountMap countAfter = StubUtil.countMethodsAndFields(classNode);
		for (Map.Entry<String, MutableInteger> c : countAfter.entrySet()) {
			// String id = c.getKey();
			MutableInteger count = c.getValue();
			Assert.assertTrue(count.getValue() == 1);
		}

		// System.out.println("----------");
		//
		// List<FieldNode> fields2 = classNode.fields;
		// for (FieldNode methodNode : fields2) {
		// if (methodNode.visibleAnnotations != null) {
		// for (AnnotationNode an : methodNode.visibleAnnotations) {
		// System.out.println("@" + an.desc + "\n"+methodNode.name +
		// methodNode.desc + "\n");
		// }
		// }
		// }
		//
		// List<MethodNode> methods2 = classNode.methods;
		// for (MethodNode methodNode : methods2) {
		// if (methodNode.visibleAnnotations != null) {
		// for (AnnotationNode an : methodNode.visibleAnnotations) {
		// System.out.println("@" + an.desc + "\n"+methodNode.name +
		// methodNode.desc + "\n");
		// }
		// }
		// }

		// // dump class to file
		// ClassWriter cw = ClassNodeTransformer
		// .createClassWriterFrom(classNode);
		// FileUtils.writeByteArrayToFile(outFile, cw.toByteArray());
	}

}
