package verification;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

import de.uni_passau.spl.featurebite.verification.JarFileClassLoader;

public class JarFileClassLoaderTest {

	List<File> files; 

	@Before
	public void before() throws FileNotFoundException, IOException {
		files = new ArrayList<File>();
		files.add(new File("examples/lib/jpf.jar"));
		files.add(new File("examples/lib/cide.jar"));
	}

	@Test(expected = ClassNotFoundException.class)
	public void testLoadFails() throws ClassNotFoundException {
		String className = "gov.nasa.jpf.JPFErrorException";
		Class.forName(className);
	}

	@Test
	public void testLoad() throws ClassNotFoundException, IOException {
		String className = "gov.nasa.jpf.JPFErrorException";
		JarFileClassLoader cl = new JarFileClassLoader(files);
		Class<?> c = cl.loadClass(className);
		Assert.assertNotNull(c);
	}

	@Test
	public void testLoad2() throws ClassNotFoundException, IOException {
		String className = "de.ovgu.cide.jakutil.ReturnObject";
		JarFileClassLoader cl = new JarFileClassLoader(files);
		Class<?> c = cl.loadClass(className);
		Assert.assertNotNull(c);
	}

}
